<template>
  <div>
    <div class="comments">
      <div class="comment" v-for="comment in comments" :key="comment.id">
        <div class="comment-wrapper">
          <div class="comment-actions">
          </div>
          <div class="user-info">
            <div class="user-avatar">
              <img src="http://i.imgur.com/cPCfLmT.jpg" alt="User Avatar" class="avatar-image" />
            </div>
            <div class="comment-bubble" v-if="comment.id !== editingCommentId">
              <!-- Contenido del comentario -->
              <div class="user-name">{{ comment.nombreUsuario }}</div>
              <div class="comment-content">{{ comment.texto }}</div>
            </div>
            <div class="comment-bubble editing editing-bubble" v-else>
              <!-- Textarea de edición -->
              <textarea v-model="comment.newText"></textarea>
              <div class="comment-actions">
                <button class="action send-comment-btn" @click="saveEditedComment(comment)">
                  <i class="mdi mdi-comment"></i> Comentar
                </button>
              </div>
              <div class="cancel-actions-container">
                <div class="comment-actions cancel-actions">
                  <span class="comment-action cancel-action subtle" @click="cancelEditing(comment)"
                    style="color: #1877F2 ">
                    Cancelar
                  </span>
                </div>
              </div>
            </div>


            <div class="comment-options" v-if="comment.isMine">
              <!-- Botón de opciones -->
              <span class="comment-action options-action subtle" @click="showOptions(comment)">
                <i class="mdi mdi-dots-horizontal"></i>
              </span>
              <!-- Menú de opciones -->
              <div class="comment-options-menu options-menu" v-if="comment.showOptions"
                :style="{ top: comment.optionPosition.top + 'px', left: comment.optionPosition.left + 'px' }">
                <span class="option" @click="editComment(comment)">Editar</span>
                <span class="option" @click="deleteComment(comment)">Eliminar</span>
              </div>

            </div>
          </div>
          <div class="comment-actions" v-if="comment.id !== editingCommentId">
            <div class="action-wrapper">
              <lista-reacciones-comentarios :publicacionId="postId" :comentarioId="comment.id"></lista-reacciones-comentarios>
              <span class="comment-action respond-action subtle" @click="showReplyForm(comment)">
                Responder
              </span>

            </div>
          </div>

          <div class="comment-replies" style="margin-top: 7px; ">
            <div class="comment-reply" v-for="reply in comment.replies" :key="reply.id" style="margin-top: 7px; ">
              <div class="user-info">
                <div class="user-avatar">
                  <img src="http://i.imgur.com/cPCfLmT.jpg" alt="User Avatar" class="avatar-image" />
                </div>
                <div class="comment-bubble" v-if="reply.id !== editingCommentId">
                  <div class="user-name">{{ reply.nombreUsuario }}</div>
                  <div class="comment-content">{{ reply.texto }}</div>
                </div>
                <div class="comment-bubble editing editing-bubble" v-else>
              <!-- Textarea de edición -->
              <textarea v-model="reply.newText"></textarea>
              <div class="comment-actions">
                <button class="action send-comment-btn" @click="saveEditedCommentReply(reply)" style="margin-left: 375px;">
                  <i class="mdi mdi-comment"></i> Comentar
                </button>
              </div>
              <div class="cancelreply-actions-container">
                <div class="comment-actions cancel-actions">
                  <span class="comment-action cancel-action subtle" @click="cancelEditing(reply)"
                    style="color: #1877F2;">
                    Cancelar
                  </span>
                </div>
              </div>
            </div>
                <div class="comment-options" v-if="reply.isMine" >
                <span class="comment-action options-action subtle" @click="showOptions(reply)"
                  >
                  <i class="mdi mdi-dots-horizontal" ></i>
                </span>
                <!-- Menú de opciones -->
                <div class="comment-options-menu options-menu" v-if="reply.showOptions"
                  :style="{ top: reply.optionPosition.top + 'px', left: reply.optionPosition.left + 'px' }">
                  <span class="option" @click="editCommentReply(reply)">Editar</span>
                  <span class="option" @click="deleteCommentReply(reply)">Eliminar</span>
                </div>
              </div>
              </div>
             
            </div>
          </div>
          <div class="comment-reply" v-if="comment.showReplyForm" style="margin-top: 7px; ">
            <div class="user-avatar">
              <img src="http://i.imgur.com/cPCfLmT.jpg" alt="User Avatar" class="avatar-image" />
            </div>
            <div class="comment-input-wrapper-response">
              <div class="comment-input-container">
                <textarea v-model="comment.replyContent" class="reply-input"
                  :placeholder="'Responder a ' + comment.nombreUsuario"></textarea>
                <div class="reply-actions">
                  <button class="action send-reply-btn" @click="addReply(comment)">
                    <i class="mdi mdi-comment"></i> Comentar
                  </button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>

    </div>
    <div class="comment-input-wrapper-container">
      <div class="user-avatar">
        <img src="http://i.imgur.com/cPCfLmT.jpg" alt="User Avatar" class="avatar-image" />
      </div>
      <div class="comment-input-wrapper">
        <div class="comment-input-container">
          <textarea v-model="newComment" placeholder="Escribe algo..."></textarea>
          <button class="action send-comment-btn" @click="addComment" :disabled="isCommentEmpty">
            <i class="mdi mdi-comment"></i> Comentar
          </button>
        </div>
      </div>
    </div>
  </div>
</template>
  
<script>
import axios from "axios";
import ListaReaccionesComentarios from '@/components/coment_react/ListaReaccionesComentarios.vue';

export default {
  components: {
    ListaReaccionesComentarios,
  },
  props: {
    postId: {
      type: Number,
      required: true
    }
  },
  data() {
    return {
      editingCommentId: null,
      newComment: "",
      hovered: false,
      selectedEmoji: null,
      comments: []

    };
  },

  created() {
    this.show();

  },
  methods: {

    show() {
      axios.get(`http://localhost:3001/comentarios/listar/${this.postId}`)
        .then(response => {
          const comments = response.data.map(comment => {
            return {
              id: comment.id,
              nombreUsuario: comment.usuario.nombreUsuario,
              texto: comment.texto,
              isMine: true,
              showOptions: false,
              optionPosition: { top: 0, left: 0 },
              isEditing: false,
            };
          });

          // Ordenar los comentarios por el id de forma ascendente
          comments.sort((a, b) => a.id - b.id);

          this.comments = comments;
        })
        .catch(error => {
          console.error(error);
        });
    },

    showAnswers(comment) {
    axios
    .get(`http://localhost:3001/comentarios/${comment.id}/respuestas`)
    .then(response => {
      const replies = response.data.map(reply => {
        return {
          id: reply.id,
          nombreUsuario: reply.usuario.nombreUsuario,
          texto: reply.texto,
          isMine: true,
          showOptions: false,
          optionPosition: { top: 0, left: 0 },
        };
      });

      // Ordenar las respuestas de menor a mayor según la ID del comentario
      replies.sort((a, b) => a.id - b.id);

      comment.replies = replies;
    })
    .catch(error => {
      console.error(error);
    });
},
    // eslint-disable-next-line
    showOptions(reply) {
      reply.showOptions = !reply.showOptions; // Alternar el valor

      if (reply.showOptions) {
        const button = event.target;
        const buttonRect = button.getBoundingClientRect();

        const optionPosition = {
          top: buttonRect.top + buttonRect.height,
          left: buttonRect.left,
        };

        reply.optionPosition = optionPosition;
      }
    },

    computed: {
      isCommentEmpty() {
        return this.newComment.trim() === "";
      },
    },
    addComment() {
      if (this.newComment.trim() === "") {
        return; // No hacer nada si el comentario está vacío
      }

      axios
        .post('http://localhost:3001/comentarios/crear', null, {
          params: {
            publicacionId: this.postId,
            texto: this.newComment,
          }
        })
        .then(response => {
          response.data;
          this.show();
          this.newComment = "";

        })
        .catch(error => {
          console.error(error);
        });
    },

    showReplyForm(comment) {
      comment.showReplyForm = !comment.showReplyForm; // Toggle the value
      comment.replyContent = ""; // Reset the reply content
      this.showAnswers(comment);

    },
    addReply(comment) {
      if (comment.replyContent.trim() === "") {
        return; // No hacer nada si el campo de respuesta está vacío
      }

      const comentarioId = comment.id; // Obtén el ID del comentario al que estás respondiendo
      const respuestaTexto = comment.replyContent; // Obtén el texto de la respuesta del comentario

      axios.post(`http://localhost:3001/comentarios/${comentarioId}/respuestas`, null, {
        params: {
          respuestaTexto: respuestaTexto
        }
      })
        .then(response => {
          response.data;

          comment.showReplyForm = false;
          comment.replyContent = "";

          // Llamar a showAnswers para mostrar las respuestas actualizadas después de agregar una nueva respuesta
          this.showAnswers(comment);
        })
        .catch(error => {
          console.error(error);
        });
    },

    // eslint-disable-next-line no-unused-vars
    likeComment(comment) {
      // ...
      this.hoveredEmoji = false;
    },
    selectEmoji(emoji) {
      this.selectedEmoji = emoji;
    },
    // eslint-disable-next-line
    showOptions(comment) {
      comment.showOptions = !comment.showOptions; // Alternar el valor

      if (comment.showOptions) {
        const button = event.target;
        const buttonRect = button.getBoundingClientRect();

        const optionPosition = {
          top: buttonRect.top + buttonRect.height,
          left: buttonRect.left,
        };

        comment.optionPosition = optionPosition;
      }
    },
    editComment(comment) {
      comment.showOptions = false;
      comment.newText = comment.texto; // Copiar el texto actual del comentario al textarea de edición
      this.editingCommentId = comment.id; // Establecer el ID del comentario en modo edición
      comment.isEditing = true;
    },
    editCommentReply(comment) {
      comment.showOptions = false;
      comment.newText = comment.texto; // Copiar el texto actual del comentario al textarea de edición
      this.editingCommentId = comment.id; // Establecer el ID del comentario en modo edición
      comment.isEditing = true;
    },
    cancelEditing(comment) {
      comment.isEditing = false;
      this.editingCommentId = null;
      comment.newText = comment.texto;
    },
    saveEditedComment(comment) {
      const nuevoTexto = comment.newText.trim();

      if (nuevoTexto === "") {
        // No permitir guardar el comentario si el nuevo texto está vacío
        return;
      }

      axios
        .put(`http://localhost:3001/comentarios/editar/${comment.id}`, null, {
          params: {
            nuevoTexto: nuevoTexto,
          }
        })
        .then(response => {
          console.log(response.data); // Comentario editado exitosamente

          comment.texto = nuevoTexto;

          this.editingCommentId = null;
          this.show();
          
        })
        .catch(error => {
          console.error(error); // Manejar el error de edición de comentario
        });
    },
    saveEditedCommentReply(comment) {
      const nuevoTexto = comment.newText.trim();

      if (nuevoTexto === "") {
        // No permitir guardar el comentario si el nuevo texto está vacío
        return;
      }

      axios
        .put(`http://localhost:3001/comentarios/editar/${comment.id}`, null, {
          params: {
            nuevoTexto: nuevoTexto,
          }
        })
        .then(response => {
          console.log(response.data); // Comentario editado exitosamente

          comment.texto = nuevoTexto;

          this.editingCommentId = null;
          
          this.showAnswers(comment);
          
        })
        .catch(error => {
          console.error(error); // Manejar el error de edición de comentario
        });
    },

    deleteComment(comment) {
      comment.showOptions = false; // Ocultar el menú de opciones

      axios
        .delete(`http://localhost:3001/comentarios/eliminar/${comment.id}`)
        .then(response => {
          console.log(response.data); // Comentario eliminado exitosamente
          this.show();
        })
        .catch(error => {
          console.error(error);
          // Maneja el error de acuerdo a tus necesidades
        });
    },
    deleteCommentReply(comment) {
  comment.showOptions = false; // Ocultar el menú de opciones

  axios
    .delete(`http://localhost:3001/comentarios/eliminar/${comment.id}`)
    .then(response => {
      console.log(response.data); // Comentario eliminado exitosamente
      
      // Eliminar la respuesta del arreglo de respuestas del comentario
      const index = comment.replies.findIndex(reply => reply.id === comment.id);
      comment.replies.splice(index, 1);

      // Llamar a showAnswers para mostrar las respuestas actualizadas después de eliminar una respuesta
      this.showAnswers(comment);
    })
    .catch(error => {
      console.error(error);
      // Maneja el error de acuerdo a tus necesidades
    });
},



  },
};
</script>
  
<style scoped>
.option {
  display: block;
  padding: 4px 8px;
  cursor: pointer;
}

.option:hover {
  background-color: #f2f2f2;
}

.comment-options {
  display: flex;
  align-items: center;
}


.comment-replies {
  margin-left: 50px;
  /* Ajusta este valor según tus necesidades */
}

.like-icon {
  display: flex;
  align-items: center;
}


.comment-reply {
  margin-left: 50px;
  /* Ajusta este valor según tus necesidades */
}

.comment-input-wrapper-response {
  display: flex;
  flex-direction: column;
  background-color: #f2f2f2;
  padding: 10px;
  border-radius: 16px;
  margin-top: 1px;
  position: relative;
  left: -5px;
  width: 90%;

}

.comment-input-wrapper-container {
  display: flex;
}

.comment-reply .user-avatar {
  width: 30px;
  height: 30px;
  border-radius: 50%;
  overflow: hidden;
  margin-right: 10px;
  float: left;
  margin-top: 5px;
}

.comment-reply .avatar-image {
  width: 100%;
  height: 100%;
  object-fit: cover;
}

i.mdi {
  font-size: 20px;
  margin-left: 5px;
}

.comment-input-wrapper-container .user-avatar {
  width: 30px;
  height: 30px;
  border-radius: 50%;
  overflow: hidden;
  margin-right: 10px;
  float: left;
  margin-top: 22px;
  /* Ajusta el valor según tu preferencia */
}

.comment-input-wrapper-container .avatar-image {
  width: 100%;
  height: 100%;
  object-fit: cover;
}

.comment-reply .comment-input-wrapper {
  display: flex;
  flex-direction: column;
  background-color: #f2f2f2;
  padding: 10px;
  border-radius: 16px;
  margin-top: 1px;
  position: relative;
  left: 40px;
  width: 90%;
}

.comment-reply .comment-input-container {
  display: flex;
  align-items: center;
  justify-content: space-between;
}

.comment-reply .reply-input {
  width: calc(100% - 80px);
  /* Reduce el ancho del textarea para dejar espacio al botón */
  height: 50px;
  padding: 5px;
  margin-top: 2px;
  border: none;
  outline: none;
  background-color: #f2f2f2;
  resize: none;
  font-family: inherit;
  font-size: 14px;
  border-radius: 16px;
  /* Misma esquina redondeada que los comentarios */
}

.comment-reply .reply-actions {
  display: flex;
  align-items: center;
  justify-content: flex-end;
  margin-top: 10px;
  position: absolute;
  /* Agrega esta línea para posicionar de forma absoluta */
  right: 10px;
  /* Ajusta la posición del botón hacia el lado derecho */
  bottom: 10px;
  /* Ajusta la posición del botón hacia la parte inferior */
}

.comment-reply .send-reply-btn {
  display: flex;
  align-items: center;
  justify-content: center;
  padding: 5px;
  background-color: transparent;
  border: none;
  color: #999999;
  cursor: pointer;
  transition: color 0.3s;
}

.comment-reply .send-reply-btn:hover {
  color: #333333;
}

.comment-reply .send-comment-btn {
  display: flex;
  align-items: center;
  justify-content: center;
  padding: 5px;
  background-color: transparent;
  border: none;
  color: #999999;
  cursor: pointer;
  transition: color 0.3s;
}

.comment-reply .send-comment-btn:hover {
  color: #333333;
}

.reply-actions {
  display: flex;
  justify-content: flex-end;
  margin-top: 10px;
}

.reply-actions .send-reply-btn {
  display: flex;
  align-items: center;
  justify-content: center;
  padding: 5px;
  background-color: transparent;
  border: none;
  color: #999999;
  cursor: pointer;
  transition: color 0.3s;
}

.comment-bubble.editing.editing-bubble {
  margin-bottom: 10px;
  /* Agrega un margen inferior */
}

.reply-actions .send-reply-btn:hover {
  color: #333333;
}

.cancel-actions-container {
  position: absolute;
  top: 87px;
  right: 575px;
  /* Ajusta el valor según sea necesario */
  bottom: 0;
  display: flex;
  align-items: center;
}
.cancelreply-actions-container{
  position: absolute;
  top: 87px;
  right: 485px;
  /* Ajusta el valor según sea necesario */
  bottom: 0;
  display: flex;
  align-items: center;
}
.comment-actions.cancel-actions {
  margin-left: auto;
}


.comment-actions {
  display: flex;
  margin-left: 50px;
  margin-top: -5px;
}

.comment-action {
  margin-right: 10px;
  cursor: pointer;
  font-size: 11px;
  color: #999999;
  transition: color 0.3s;
}

.comment-action:hover {
  text-decoration: underline;
  color: #333333;
}

.comment-input-wrapper {
  display: flex;
  flex-direction: column;
  background-color: #f2f2f2;
  padding: 10px;
  border-radius: 16px;
  margin-top: 20px;
  position: relative;
  left: 40px;
  width: 90%;
  margin-left: -45px;
}

.editing-bubble {
  display: flex;
  flex-direction: column;
  background-color: #f2f2f2;
  padding: 10px;
  border-radius: 16px;
  margin-top: 20px;
  position: relative;
  left: 40px;
  width: 90%;
  margin-left: -45px;


}

.editing-bubble .send-comment-btn {
  margin-top: -28px;
  margin-left: 468px;
}

.comment-input-container {
  display: flex;
  align-items: center;
  justify-content: space-between;
}

textarea {
  width: 100%;
  height: 50px;
  padding: 5px;
  /* Reduce el padding para ajustarlo al texto */
  margin-top: 2px;
  /* Ajusta el margen según tus necesidades */
  border: none;
  /* Elimina el borde */
  outline: none;
  /* Elimina el resaltado del enfoque */
  background-color: transparent;
  /* Hace que el fondo sea transparente */
  resize: none;
  /* Evita que el usuario redimensione el textarea */
  font-family: inherit;
  /* Usa la fuente del contenedor padre */
  font-size: 14px;
  /* Ajusta el tamaño de fuente según tus necesidades */
}

.send-comment-btn {
  display: flex;
  align-items: center;
  justify-content: center;
  padding: 5px;
  background-color: transparent;
  border: none;
  color: #999999;
  cursor: pointer;
  transition: color 0.3s;
}

.send-comment-btn:hover {
  color: #333333;
}

.comments {
  border-top: 1px solid #ccc;
  padding-top: 10px;

}

.comment .comment-wrapper {
  display: flex;
  flex-direction: column;
  margin-bottom: 10px;
}

.comment .user-info {
  display: flex;
  align-items: center;
  justify-content: flex-start;
  margin-bottom: 0;

}

.comment .user-avatar {
  width: 30px;
  height: 30px;
  border-radius: 50%;
  overflow: hidden;
  margin-right: 10px;
}

.comment .avatar-image {
  width: 100%;
  height: 100%;
  object-fit: cover;
}

.comment .comment-bubble {
  background-color: #f2f2f2;
  padding: 8px;
  border-radius: 16px;
  /* Cambia el valor del radio de borde */

}

.comment .user-name {
  font-size: 12px;
  color: #333333;
  font-weight: bold;
  text-align: left;
}

.comment .comment-content {
  margin-top: 0px;
  text-align: left;
}

.send-comment-btn {
  margin-top: 10px;
}

.comment-content {
  text-align: left;
  margin-top: -10px;
  font-size: 14px;
}

.underline {
  text-decoration: underline;
}

.hoverable:hover {
  cursor: pointer;
  opacity: 0.7;
}

.subtle {
  color: #999999;
}
</style>
  